searchData={"items":[{"type":"module","title":"Ueberauth.Strategy.PagerDuty","doc":"PagerDuty Strategy for Überauth.","ref":"Ueberauth.Strategy.PagerDuty.html"},{"type":"function","title":"Ueberauth.Strategy.PagerDuty.credentials/1","doc":"","ref":"Ueberauth.Strategy.PagerDuty.html#credentials/1"},{"type":"function","title":"Ueberauth.Strategy.PagerDuty.default_options/0","doc":"","ref":"Ueberauth.Strategy.PagerDuty.html#default_options/0"},{"type":"function","title":"Ueberauth.Strategy.PagerDuty.extra/1","doc":"","ref":"Ueberauth.Strategy.PagerDuty.html#extra/1"},{"type":"function","title":"Ueberauth.Strategy.PagerDuty.handle_callback!/1","doc":"","ref":"Ueberauth.Strategy.PagerDuty.html#handle_callback!/1"},{"type":"function","title":"Ueberauth.Strategy.PagerDuty.handle_cleanup!/1","doc":"","ref":"Ueberauth.Strategy.PagerDuty.html#handle_cleanup!/1"},{"type":"function","title":"Ueberauth.Strategy.PagerDuty.handle_request!/1","doc":"","ref":"Ueberauth.Strategy.PagerDuty.html#handle_request!/1"},{"type":"function","title":"Ueberauth.Strategy.PagerDuty.info/1","doc":"","ref":"Ueberauth.Strategy.PagerDuty.html#info/1"},{"type":"function","title":"Ueberauth.Strategy.PagerDuty.uid/1","doc":"","ref":"Ueberauth.Strategy.PagerDuty.html#uid/1"},{"type":"module","title":"Ueberauth.Strategy.PagerDuty.OAuth","doc":"An implementation of OAuth2 for PagerDuty.\n\nTo add your `:client_id` and `:client_secret` include these values in your\nconfiguration:\n\n    config :ueberauth, Ueberauth.Strategy.PagerDuty.OAuth,\n      client_id: System.get_env(\"PAGERDUTY_CLIENT_ID\"),\n      client_secret: System.get_env(\"PAGERDUTY_CLIENT_SECRET\")","ref":"Ueberauth.Strategy.PagerDuty.OAuth.html"},{"type":"function","title":"Ueberauth.Strategy.PagerDuty.OAuth.authorize_url/2","doc":"","ref":"Ueberauth.Strategy.PagerDuty.OAuth.html#authorize_url/2"},{"type":"function","title":"Ueberauth.Strategy.PagerDuty.OAuth.authorize_url!/2","doc":"Provides the authorize url for the request phase of Ueberauth.\n\nNo need to call this usually.","ref":"Ueberauth.Strategy.PagerDuty.OAuth.html#authorize_url!/2"},{"type":"function","title":"Ueberauth.Strategy.PagerDuty.OAuth.client/1","doc":"Construct a client for requests to PagerDuty.\n\nOptionally include any OAuth2 options here to be merged with the defaults:\n\n    Ueberauth.Strategy.PagerDuty.OAuth.client(\n      redirect_uri: \"http://localhost:4000/auth/pagerduty/callback\"\n    )\n\nThis will be setup automatically for you in `Ueberauth.Strategy.PagerDuty`.\n\nThese options are only useful for usage outside the normal callback phase of\nUeberauth.","ref":"Ueberauth.Strategy.PagerDuty.OAuth.html#client/1"},{"type":"function","title":"Ueberauth.Strategy.PagerDuty.OAuth.get/4","doc":"","ref":"Ueberauth.Strategy.PagerDuty.OAuth.html#get/4"},{"type":"function","title":"Ueberauth.Strategy.PagerDuty.OAuth.get_token/3","doc":"","ref":"Ueberauth.Strategy.PagerDuty.OAuth.html#get_token/3"},{"type":"function","title":"Ueberauth.Strategy.PagerDuty.OAuth.get_token!/2","doc":"","ref":"Ueberauth.Strategy.PagerDuty.OAuth.html#get_token!/2"},{"type":"extras","title":"Überauth PagerDuty","doc":"# Überauth PagerDuty\n\n> PagerDuty OAuth2 strategy for Überauth.","ref":"readme.html"},{"type":"extras","title":"Installation - Überauth PagerDuty","doc":"1.  Setup your application at [PagerDuty Developer](https://developer.pagerduty.com).\n\n2.  Add `:ueberauth_pagerduty` to your list of dependencies in `mix.exs`:\n\n    ```elixir\n    def deps do\n      [\n        {:ueberauth_pagerduty, \"~> 0.1.1\"}\n      ]\n    end\n    ```\n\n3.  Add PagerDuty to your Überauth configuration:\n\n    ```elixir\n    config :ueberauth, Ueberauth,\n      providers: [\n        pagerduty: {Ueberauth.Strategy.PagerDuty, []}\n      ]\n    ```\n\n4.  Update your provider configuration:\n\n    ```elixir\n    config :ueberauth, Ueberauth.Strategy.PagerDuty.OAuth,\n      client_id: System.get_env(\"PAGERDUTY_CLIENT_ID\"),\n      client_secret: System.get_env(\"PAGERDUTY_CLIENT_SECRET\"),\n      redirect_uri: System.get_env(\"PAGERDUTY_REDIRECT_URI\")\n    ```\n\n    Or, to read the client credentials at runtime:\n\n    ```elixir\n    config :ueberauth, Ueberauth.Strategy.PagerDuty.OAuth,\n      client_id: {:system, \"PAGERDUTY_CLIENT_ID\"},\n      client_secret: {:system, \"PAGERDUTY_CLIENT_SECRET\"},\n      redirect_uri: {:system, \"PAGERDUTY_REDIRECT_URI\"}\n    ```\n\n5.  Include the Überauth plug in your router:\n\n    ```elixir\n    defmodule MyApp.Router do\n      use MyApp.Web, :router\n\n      pipeline :browser do\n        plug Ueberauth\n        ...\n       end\n    end\n    ```\n\n6.  Create the request and callback routes if you haven't already:\n\n    ```elixir\n    scope \"/auth\", MyApp do\n      pipe_through :browser\n\n      get \"/:provider\", AuthController, :request\n      get \"/:provider/callback\", AuthController, :callback\n    end\n    ```\n\n7.  Your controller needs to implement callbacks to deal with `Ueberauth.Auth`\n    and `Ueberauth.Failure` responses.\n\nFor an example implementation see the [Überauth Example](https://github.com/ueberauth/ueberauth_example) application.","ref":"readme.html#installation"},{"type":"extras","title":"Calling - Überauth PagerDuty","doc":"Depending on the configured url you can initiate the request through:\n\n    /auth/pagerduty\n\nOr with options:\n\n    /auth/pagerduty?scope=write\n\nBy default the requested scope is `\"write\"`. This provides both read\nand write access to the PagerDuty API (via classic auth).\n\nScope can be configured either explicitly as a `scope` query value on the\nrequest path or in your configuration:\n\n```elixir\nconfig :ueberauth, Ueberauth,\n  providers: [\n    pagerduty: {Ueberauth.Strategy.PagerDuty, [default_scope: \"write\"]}\n  ]\n```","ref":"readme.html#calling"},{"type":"extras","title":"Credits - Überauth PagerDuty","doc":"Originally a fork of the [GitHub ueberauth strategy](https://github.com/ueberauth/ueberauth_github).","ref":"readme.html#credits"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),\nand this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).","ref":"changelog.html"},{"type":"extras","title":"v0.1.1 - Changelog","doc":"Relax ueberauth versioning ~> 0.10","ref":"changelog.html#v0-1-1"},{"type":"extras","title":"v0.1.0 - Changelog","doc":"* Initial release","ref":"changelog.html#v0-1-0"},{"type":"extras","title":"LICENSE","doc":"The MIT License (MIT)\n\nCopyright (c) 2015 Daniel Neighman, (c) 2023 Thomas Edgesmith\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"}],"content_type":"text/markdown"}